#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <cstring>
using namespace std;
int n, q, minc = 1000000007, maxc;
int a[1005][1005];
struct edge
{
    int ver, w;
};
vector <edge> v[100005];
void read()
{
    cin >> n >> q;
    int ui, vi, wi;
    for(int i = 1; i < n; i++)
    {
        cin >> ui >> vi >> wi;
        v[ui].push_back({vi, wi});
        v[vi].push_back({ui, wi});
        if(wi < minc)minc = wi;
        if(wi > maxc)maxc = wi;
    }
}
int used[1024];
void BFS(int beg)
{
    queue <int> q;
    q.push(beg);
    used[beg] = 1;
    while(!q.empty())
    {
        int ver = q.front();
        q.pop();
        for(int i = 0; i < v[ver].size(); i++)
        {
            if(!used[v[ver][i].ver])
            {
                a[beg][v[ver][i].ver] = max(a[beg][ver], v[ver][i].w);
                ///cout << beg << " " << ver << " " << v[ver][i].ver << " " << a[beg][ver] << " " << v[ver][i].w << endl;
                q.push(v[ver][i].ver);
                used[v[ver][i].ver] = 1;
            }
        }
    }
}
void fill_a()
{
    for(int i = 1; i <= n; i++)
    {
        memset(used, 0, sizeof(used));
        BFS(i);
    }
}
map <int, int> m;
void fill_m()
{
    for(int i = 1; i < n; i++)
    {
        for(int j = i+1; j <= n; j++)
        {
            ///cout << i << " " << j << " " << a[i][j] << endl;
            m[a[i][j]]++;
        }
    }
}
void query(int l, int r)
{
    long long sum = 0;
    if(l < minc)l = minc;
    if(r > maxc)r = maxc;
    for(int i = l; i <= r; i++)
    {
        sum += m[i]*i;
    }
    cout << sum << endl;
}
void solve()
{
    int l, r;
    for(int i = 1; i <= q; i++)
    {
        cin >> l >> r;
        query(l, r);
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    fill_a();
    fill_m();
    solve();
    return 0;
}
/*
50 6
1 2 1
1 3 1
1 4 2
2 9 7
3 7 8
3 10 2
4 5 3
9 15 8
9 16 1
7 11 7
10 17 8
5 6 4
5 8 1
15 25 7
16 26 2
11 14 6
11 12 6
11 13 4
17 27 9
6 18 8
8 19 1
25 31 4
14 24 5
13 23 3
12 21 5
18 20 1
31 38 3
31 38 2
38 47 8
38 48 10
24 32 3
32 37 4
37 46 4
46 50 6
23 30 4
30 10 8
40 49 5
21 22 4
22 33 2
22 34 3
33 45 10
20 28 2
20 29 3
20 35 5
35 36 6
28 41 9
28 42 8
42 44 7
42 43 1
*/
