#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
#define ll long long
#define a second.first
#define b second.second
#define w first
#define num second
#define int3 pair<int, pair<int, int>>
int parent[100005];
int height[100005];
int sz[100005];
int3 edge[100005];
ll pref[100005];
vector<pair<int, int>> path;
int bin_search(int x, bool findGr) {
    int l = -1, r = path.size();
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (path[m].w == x) {
            return m + (!findGr);
        }
        if (path[m].w < x) {
            l = m;
        } else {
            r = m;
        }
    }
    return r;
}

int findRoot(int x) {
    int cur = x;
    while (parent[cur] != 0) {
        cur = parent[cur];
    }
    int last = x;
    while (parent[x] != 0) {
        x = parent[x];
        parent[last] = cur;
        last = x;
    }
    return cur;
}

void mergeSets(int x, int y) {
    x = findRoot(x);
    y = findRoot(y);
    if (height[x] < height[y]) {
        parent[x] = y;
        sz[y] += sz[x];
    } else {
        if (height[x] > height[y]) {
            parent[y] = x;
            sz[x] += sz[y];
        } else {
            parent[x] = y;
            sz[y] += sz[x];
            height[y]++;
        }
    }
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n - 1; i++) {
        cin >> edge[i].a >> edge[i].b >> edge[i].w;
        edge[i].a--;
        edge[i].b--;
        sz[i] = 1;
        parent[i] = 0;
        height[i] = 0;
        pref[i] = 0;
    }
    sz[n - 1] = 1;
    parent[n - 1] = 0;
    height[n - 1] = 0;
    pref[n - 1] = 0;
    sort(edge, edge + n - 1);
    ll cur = 0;
    for (int i = 0; i < n - 1; i++) {
        if (path.size() != 0 && path[path.size() - 1].w != edge[i].w) {
            cur = 0;
        }
        cur += sz[findRoot(edge[i].a)] * sz[findRoot(edge[i].b)];
        mergeSets(edge[i].a, edge[i].b);
        if (path.size() != 0 && path[path.size() - 1].w == edge[i].w) {
            path[path.size() - 1].num = cur;
        } else {
            path.push_back(make_pair(edge[i].w, cur));
        }
    }
    ll curSum = 0;
    for (int i = 0; i < path.size(); i++) {
        pref[i] = curSum;
        curSum += path[i].w * path[i].num;
    }
    pref[path.size()] = curSum;

    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;
        cout << pref[bin_search(r, 0)] - pref[bin_search(l, 1)] << "\n";
    }
}
