#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
#define ll long long
#define a second.first
#define b second.second
#define w first
#define num second
#define ll3 pair<ll, pair<ll, ll>>
ll parent[100005];
ll height[100005];
ll sz[100005];
ll3 edge[100005];
ll pref[100005];
vector<pair<ll, ll>> path;
ll bin_search(ll x) {
    ll l = -1, r = path.size();
    while (l + 1 < r) {
        ll m = (l + r) / 2;
        if (path[m].w == x) {
            return m;
        }
        if (path[m].w < x) {
            l = m;
        } else {
            r = m;
        }
    }
    return r;
}

ll findRoot(ll x) {
    ll root = x;
    while (parent[root] != 0) {
        root = parent[root];
    }
    ll last = x;
    while (parent[x] != 0) {
        last = x;
        x = parent[x];
        parent[last] = root;
    }
    return root;
}

void mergeSets(ll x, ll y) {
    x = findRoot(x);
    y = findRoot(y);
    if (height[x] < height[y]) {
        parent[x] = y;
        sz[y] += sz[x];
        sz[x] = 0;
    } else {
        if (height[x] > height[y]) {
            parent[y] = x;
            sz[x] += sz[y];
            sz[y] = 0;
        } else {
            parent[x] = y;
            sz[y] += sz[x];
            sz[x] = 0;
            height[y]++;
        }
    }
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, q;
    cin >> n >> q;
    for (ll i = 0; i < n - 1; i++) {
        cin >> edge[i].a >> edge[i].b >> edge[i].w;
        edge[i].a--;
        edge[i].b--;
        sz[i] = 1;
        parent[i] = 0;
        height[i] = 0;
        pref[i] = 0;
    }
    sz[n - 1] = 1;
    parent[n - 1] = 0;
    height[n - 1] = 0;
    pref[n - 1] = 0;
    sort(edge, edge + n - 1);
    ll cur = 0;
    for (ll i = 0; i < n - 1; i++) {
        if (path.size() == 0 || path[path.size() - 1].w != edge[i].w) {
            cur = 0;
        }
        cur += sz[findRoot(edge[i].a)] * sz[findRoot(edge[i].b)];
        mergeSets(edge[i].a, edge[i].b);
        if (path.size() != 0 && path[path.size() - 1].w == edge[i].w) {
            path[path.size() - 1].num = cur;
        } else {
            path.push_back(make_pair(edge[i].w, cur));
        }
    }
    ll curSum = 0;
    for (ll i = 0; i < path.size(); i++) {
        pref[i] = curSum;
        curSum += path[i].w * path[i].num;
    }
    pref[path.size()] = curSum;

    for (ll i = 0; i < q; i++) {
        ll l, r;
        cin >> l >> r;
        cout << pref[bin_search(r + 1)] - pref[bin_search(l)] << "\n";
    }
}
