#include <bits/stdc++.h>
using namespace std;

vector <pair <int, int>> edges[100001];
int n;

int BR = 1;

unordered_map <int, int> COMPRESS;

int compress(int x) {
    int& val = COMPRESS[x];
    if (val != 0) return val;
    return val = BR++;
}

int a[100001]; /// parent
int b[100001]; /// highest value of edge in node component (root)
unordered_map <int, long long> c; /// amount
int size[100001];

int root(int u) {
    if (a[u] == u) return u;
    return a[u] = root(a[u]);
}

void connect(int u, int v, int val) {
    ///int u = edge.second.first, v = edge.second.second;
    //int val = compress(edge.first);

    //cout << "Attempting: " << u << ", " << v << ";\n";
    if (root(u) == root(v)) return;
    //cout << "Connecting: " << u << ", " << v << ";\n";

    ///if (b[root(u)] != edge.first) c[edge.first] += size[root(u)];
    ///if (b[root(v)] != edge.first) c[edge.first] += size[root(v)];

    size[root(v)] += size[root(u)];
    size[root(u)] = 0;
    a[root(u)] = root(v);
}

vector <pair <int, int>> cost;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int q;
    cin >> n >> q;

    vector <pair <int, pair <int, int>>> tree_edges;

    for (int i = 1; i < n; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        edges[u].push_back({w, v});
        edges[v].push_back({w, u});

        tree_edges.push_back({w, {u, v}});
        a[i] = i;
        size[i] = 1;
    }

    a[n] = n;
    size[n] = 1;

    sort(tree_edges.begin(), tree_edges.end());

    vector <pair <int, int>> compressed;

    vector <pair <int, vector <pair <int, int>>>> tree;



    for (int i = 0; i < tree_edges.size(); i++) {
        if (i == 0 || tree.back().first != tree_edges[i].first) tree.push_back({tree_edges[i].first, vector <pair <int, int>> ()});
        tree.back().second.push_back(tree_edges[i].second);
    }

    for (int i = 0; i < tree.size(); i++) {
        int val = tree[i].first;
        long long& r = c[val];

        for (auto x : tree[i].second) {
            //cout << x.first << ' ' << x.second << ' ' << size[root(x.first)] << ' ' << size[root(x.second)] << endl;
            r += size[root(x.first)] * size[root(x.second)];
            connect(x.first, x.second, val);
        }

        //cout << "CONNECTED WITH VALUE " << val << endl;
    }

    //cout << endl << endl << endl;

    vector <pair <int, long long>> values(1);

    for (auto x : c) {
        values.push_back({x.first, x.second * x.first});
    }

    sort(values.begin() + 1, values.end());

    vector <long long> prefix(values.size());

    for (int i = 1; i < values.size(); i++) {
        prefix[i] = prefix[i - 1] + values[i].second;
    }

    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;

        auto left_it = lower_bound(values.begin() + 1, values.end(), pair <int, long long> (l, INT_MIN));
        int left_idx = left_it - values.begin();
        auto right_it = upper_bound(values.begin() + 1, values.end(), pair <int, long long> (r, INT_MAX)) - 1;
        int right_idx = right_it - values.begin();

        cout << prefix[right_idx] - prefix[left_idx - 1] << '\n';
    }

    return 0;

}

