#include <bits/stdc++.h>
using namespace std;

vector <pair <unsigned long long, unsigned long long>> edges[100001];
unsigned long long n;

unsigned long long BR = 1;

unordered_map <unsigned long long, unsigned long long> COMPRESS;

unsigned long long compress(unsigned long long x) {
    unsigned long long& val = COMPRESS[x];
    if (val != 0) return val;
    return val = BR++;
}

unsigned long long a[100001]; /// parent
unsigned long long b[100001]; /// highest value of edge in node component (root)
unordered_map <unsigned long long, unsigned long long> c; /// amount
unsigned long long size[100001];

unsigned long long root(unsigned long long u) {
    if (a[u] == u) return u;
    return a[u] = root(a[u]);
}

void connect(unsigned long long u, unsigned long long v, unsigned long long val) {
    ///unsigned long long u = edge.second.first, v = edge.second.second;
    //unsigned long long val = compress(edge.first);

    //cout << "Attempting: " << u << ", " << v << ";\n";
    if (root(u) == root(v)) return;
    //cout << "Connecting: " << u << ", " << v << ";\n";

    ///if (b[root(u)] != edge.first) c[edge.first] += size[root(u)];
    ///if (b[root(v)] != edge.first) c[edge.first] += size[root(v)];

    size[root(v)] += size[root(u)];
    size[root(u)] = 0;
    a[root(u)] = root(v);
}

vector <pair <unsigned long long, unsigned long long>> cost;

signed main() {

    //ios_base::sync_with_stdio(false);
    cin.tie(0);
    //cout.tie(0);

    unsigned long long q;
    cin >> n >> q;

    vector <pair <unsigned long long, pair <unsigned long long, unsigned long long>>> tree_edges;

    for (unsigned long long i = 1; i < n; i++) {
        unsigned long long u, v, w;
        cin >> u >> v >> w;
        edges[u].push_back({w, v});
        edges[v].push_back({w, u});

        tree_edges.push_back({w, {u, v}});
        a[i] = i;
        size[i] = 1;
    }

    a[n] = n;
    size[n] = 1;

    sort(tree_edges.begin(), tree_edges.end());

    vector <pair <unsigned long long, unsigned long long>> compressed;

    vector <pair <unsigned long long, vector <pair <unsigned long long, unsigned long long>>>> tree;

    for (unsigned long long i = 0; i < tree_edges.size(); i++) {
        if (i == 0 || tree.back().first != tree_edges[i].first) tree.push_back({tree_edges[i].first, vector <pair <unsigned long long, unsigned long long>> ()});
        tree.back().second.push_back(tree_edges[i].second);
    }

    for (unsigned long long i = 0; i < tree.size(); i++) {
        unsigned long long val = tree[i].first;
        unsigned long long& r = c[val];

        for (auto x : tree[i].second) {
            //cout << x.first << ' ' << x.second << ' ' << size[root(x.first)] << ' ' << size[root(x.second)] << endl;
            r += size[root(x.first)] * size[root(x.second)];
            connect(x.first, x.second, val);
        }

        //cout << "CONNECTED WITH VALUE " << val << endl;
    }

    //cout << endl << endl << endl;

    vector <pair <unsigned long long, unsigned long long>> values(1);

    for (auto x : c) {
        values.push_back({x.first, x.second * x.first});
    }

    sort(values.begin() + 1, values.end());

    vector <unsigned long long> prefix(values.size());

    for (unsigned long long i = 1; i < values.size(); i++) {
        prefix[i] = prefix[i - 1] + values[i].second;
    }

    for (unsigned long long i = 0; i < q; i++) {
        unsigned long long l, r;
        cin >> l >> r;

        auto left_it = lower_bound(values.begin() + 1, values.end(), pair <unsigned long long, unsigned long long> (l, -1e12));
        unsigned long long left_idx = left_it - values.begin();
        auto right_it = upper_bound(values.begin() + 1, values.end(), pair <unsigned long long, unsigned long long> (r, 1e12)) - 1;
        unsigned long long right_idx = right_it - values.begin();

        cout << prefix[right_idx] - prefix[left_idx - 1] << '\n';
    }

    return 0;

}

