#include <bits/stdc++.h>
using namespace std;

long long dp[1001][1001], visited[1001][1001];
long long depth[1001], parent[1001], parent_dist[1001];

vector <pair <int, int>> edges[1001];

void dfs(int u, int v) {
    parent[v] = u;
    depth[v] = depth[u] + 1;

    for (auto p : edges[v]) {
        if (p.second == u) continue;
        parent_dist[p.second] = p.first;
        dfs(v, p.second);
    }
}

long long dist(int u, int v) {
    if (u == v) return 0;

    if (visited[u][v]) return dp[u][v];
    visited[u][v] = 1;

    if (depth[u] <= depth[v]) return dp[u][v] = max(parent_dist[v], dist(u, parent[v]));
    return dp[u][v] = max(parent_dist[u], dist(v, parent[u]));
}

unordered_map <int, long long> CC;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> q;

    for (int i = 1; i < n; i++) {
        int u, v, w;
        cin >> u >> v >> w;

        edges[u].push_back({w, v});
        edges[v].push_back({w, u});
    }

    dfs(1, 1);

    vector <pair <long long, long long>> values(1);

    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j++) {
            CC[dist(i, j)]++;
        }
    }

    for (auto p : CC) {
        values.push_back({p.first, p.second * p.first});
        //cout << "DEBUG " << p.first << ' ' << p.second * p.first << endl;
    }

    sort(values.begin() + 1, values.end());

    vector <long long> prefix(values.size());

    for (long long i = 1; i < values.size(); i++) {
        prefix[i] = prefix[i - 1] + values[i].second;
        //cout << "DEBUG PREFIX " << i << ' ' << prefix[i] << endl;
    }

    for (long long i = 0; i < q; i++) {
        long long l, r;
        cin >> l >> r;

        auto left_it = lower_bound(values.begin() + 1, values.end(), pair <long long, long long> (l, -1e9));
        long long left_idx = left_it - values.begin();
        auto right_it = upper_bound(values.begin() + 1, values.end(), pair <long long, long long> (r, 1e9)) - 1;
        long long right_idx = right_it - values.begin();
        //cout << "DEBUG IDX" << left_idx << ' ' << right_idx << endl;

        cout << prefix[right_idx] - prefix[left_idx - 1] << '\n';
    }

    return 0;

}
