#include <bits/stdc++.h>
using namespace std;

long long n, q;
long long dp[1001][1001], visited[1001][1001];
long long depth[1001], parent[1001], parent_dist[1001];

vector <pair <int, int>> edges[1001];

void dfs(int u, int v) {
    parent[v] = u;
    depth[v] = depth[u] + 1;

    for (auto p : edges[v]) {
        if (p.second == u) continue;
        parent_dist[p.second] = p.first;
        dfs(v, p.second);
    }
}

long long dist(int u, int v) {
    if (u == v) return 0;

    if (visited[u][v]) return dp[u][v];
    visited[u][v] = 1;

    if (depth[u] <= depth[v]) return dp[u][v] = max(parent_dist[v], dist(u, parent[v]));
    return dp[u][v] = max(parent_dist[u], dist(v, parent[u]));
}

unordered_map <int, long long> CC;

vector <long long> slow() {

    ifstream CIN("input.in");

    CIN >> n >> q;

    for (int i = 1; i < n; i++) {
        int u, v, w;
        CIN >> u >> v >> w;

        edges[u].push_back({w, v});
        edges[v].push_back({w, u});
    }

    dfs(1, 1);

    vector <pair <long long, long long>> values(1);

    long long BR = 0;

    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j++) {
            //CC[dist(i, j)]++;
            BR += dist(i, j);
        }
    }

    cout << BR << endl;
    return 0;

    for (auto p : CC) {
        values.push_back({p.first, p.second * p.first});
        //cout << "DEBUG " << p.first << ' ' << p.second * p.first << endl;
    }

    sort(values.begin() + 1, values.end());

    vector <long long> prefix(values.size());

    for (long long i = 1; i < values.size(); i++) {
        prefix[i] = prefix[i - 1] + values[i].second;
        //cout << "DEBUG PREFIX " << i << ' ' << prefix[i] << endl;
    }

    vector <long long> ans;

    for (long long i = 0; i < q; i++) {
        long long l, r;
        CIN >> l >> r;

        auto left_it = lower_bound(values.begin() + 1, values.end(), pair <long long, long long> (l, -1e9));
        long long left_idx = left_it - values.begin();
        auto right_it = upper_bound(values.begin() + 1, values.end(), pair <long long, long long> (r, 1e9)) - 1;
        long long right_idx = right_it - values.begin();
        //cout << "DEBUG IDX" << left_idx << ' ' << right_idx << endl;

        ans.push_back(prefix[right_idx] - prefix[left_idx - 1]);
    }


    return ans;

}


unsigned long long BR = 1;

unordered_map <unsigned long long, unsigned long long> COMPRESS;

unsigned long long compress(unsigned long long x) {
    unsigned long long& val = COMPRESS[x];
    if (val != 0) return val;
    return val = BR++;
}

unsigned long long a[100001]; /// parent
unsigned long long b[100001]; /// highest value of edge in node component (root)
unordered_map <unsigned long long, unsigned long long> c; /// amount
unsigned long long size[100001];

unsigned long long root(unsigned long long u) {
    if (a[u] == u) return u;
    return a[u] = root(a[u]);
}

void connect(unsigned long long u, unsigned long long v, unsigned long long val) {
    ///unsigned long long u = edge.second.first, v = edge.second.second;
    //unsigned long long val = compress(edge.first);

    //cout << "Attempting: " << u << ", " << v << ";\n";
    if (root(u) == root(v)) return;
    //cout << "Connecting: " << u << ", " << v << ";\n";

    ///if (b[root(u)] != edge.first) c[edge.first] += size[root(u)];
    ///if (b[root(v)] != edge.first) c[edge.first] += size[root(v)];

    size[root(v)] += size[root(u)];
    size[root(u)] = 0;
    a[root(u)] = root(v);
}

vector <pair <unsigned long long, unsigned long long>> cost;

vector <long long> fast() {

    ifstream CIN("input.in");

    CIN >> n >> q;

    vector <pair <unsigned long long, pair <unsigned long long, unsigned long long>>> tree_edges;

    for (unsigned long long i = 1; i < n; i++) {
        unsigned long long u, v, w;
        CIN >> u >> v >> w;
        edges[u].push_back({w, v});
        edges[v].push_back({w, u});

        tree_edges.push_back({w, {u, v}});
        a[i] = i;
        size[i] = 1;
    }

    a[n] = n;
    size[n] = 1;

    sort(tree_edges.begin(), tree_edges.end());

    vector <pair <unsigned long long, unsigned long long>> compressed;

    vector <pair <unsigned long long, vector <pair <unsigned long long, unsigned long long>>>> tree;

    for (unsigned long long i = 0; i < tree_edges.size(); i++) {
        if (i == 0 || tree.back().first != tree_edges[i].first) tree.push_back({tree_edges[i].first, vector <pair <unsigned long long, unsigned long long>> ()});
        tree.back().second.push_back(tree_edges[i].second);
    }

    for (unsigned long long i = 0; i < tree.size(); i++) {
        unsigned long long val = tree[i].first;
        unsigned long long& r = c[val];

        for (auto x : tree[i].second) {
            //cout << x.first << ' ' << x.second << ' ' << size[root(x.first)] << ' ' << size[root(x.second)] << endl;
            r += size[root(x.first)] * size[root(x.second)];
            connect(x.first, x.second, val);
        }

        //cout << "CONNECTED WITH VALUE " << val << endl;
    }

    //cout << endl << endl << endl;

    vector <pair <unsigned long long, unsigned long long>> values(1);

    for (auto x : c) {
        values.push_back({x.first, x.second * x.first});
    }

    sort(values.begin() + 1, values.end());

    vector <unsigned long long> prefix(values.size());

    for (unsigned long long i = 1; i < values.size(); i++) {
        prefix[i] = prefix[i - 1] + values[i].second;
    }

    vector <long long> ans;

    for (unsigned long long i = 0; i < q; i++) {
        unsigned long long l, r;
        CIN >> l >> r;

        auto left_it = lower_bound(values.begin() + 1, values.end(), pair <unsigned long long, unsigned long long> (l, -1e12));
        unsigned long long left_idx = left_it - values.begin();
        auto right_it = upper_bound(values.begin() + 1, values.end(), pair <unsigned long long, unsigned long long> (r, 1e12)) - 1;
        unsigned long long right_idx = right_it - values.begin();

        ans.push_back(prefix[right_idx] - prefix[left_idx - 1]);
    }

    return ans;

}

int main() {

    srand(time(0));
    freopen("input.in", "r", stdin);

    while (1) {
        int n = rand() % 6 + 1;
        int q = rand() % 10 + 1;
        ofstream s("input.in");
        s << n << ' ' << q << endl;

        for (int i = 2; i <= n; i++) {
            int r = rand() % (i - 1) + 1, costs = rand() % 5 + 1;
            s << i << ' ' << r << ' ' << costs << endl;
        }

        for (int i = 1; i <= q; i++) {
            int l = rand() % 10 + 1;
            int r = rand() % 10 + 1;

            if (l > r) swap(l, r);
            s << l << ' ' << r << endl;
        }

        s.close();

        if (fast() != slow()) {
            ifstream CIN("input.in");
            int aa;

            while (CIN >> aa) {
                cout << aa << ' ';
            }

            break;
        }
    }

}
