#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e6 + 1;
int N, Q, G;
string S;
int Prefix[MAXN];
int Active[MAXN];
int Add[MAXN];
vector<tuple<int, int, int>> Points;
pair<int, int> Questions[MAXN];
deque<int> Dq[MAXN];

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> Q >> G;
    cin >> S;

    stack<int> St;

    for(int i = 0; i < (int)S.size(); i++)
    {
        if(S[i] =='(')
        {
            St.push(i);
            Prefix[i + 1]++;
        }
        else
        {
            if(!St.empty() && S[St.top()] == '(')
            {
                Points.push_back({St.top() + 1, 0, 0});
                Points.push_back({i + 1, 1, 0});
                Prefix[i + 1]--;
                St.pop();
            }
            else
            {
                St.push(i);
            }
        }
    }

    for(int i = 1; i <= (int)S.size(); i++)
    {
        Prefix[i] += Prefix[i - 1];
    }
}

int Query(int left, int right, int i)
{
    int Size = Prefix[right] - Prefix[left - 1] + Add[i];
    int Ans = Size / 2;

    if(Size % 2 != 0)
    {
        Ans++;
    }

    return Ans;
}

void Solve()
{
    for(int i = 1; i <= Q; i++)
    {
        cin >> Questions[i].first >> Questions[i].second;
        Points.push_back({Questions[i].first - 1, 0, i});
        Points.push_back({Questions[i].second, 1, i});
    }

    sort(Points.begin(), Points.end());

    deque<int> Curr;

    for(int i = 0 ; i < Points.size(); i++)
    {
        if(get<2>(Points[i]) == 0)
        {
            if(get<1>(Points[i]) == 0)
            {
                Curr.push_back(i);
            }
            else
            {
                Curr.pop_back();
            }
        }
        else
        {
            if(get<1>(Points[i]) == 0)
            {
                Dq[get<2>(Points[i])] = Curr;
            }
            else
            {
                if(Dq[get<2>(Points[i])].empty() || Curr.empty())
                {
                    continue;
                }

                Add[get<2>(Points[i])] = Dq[get<2>(Points[i])].size();

                int j = 0;

                while(j < Dq[get<2>(Points[i])].size() && j < Curr.size() && Dq[get<2>(Points[i])][j] == Curr[j])
                {
                    Add[get<2>(Points[i])]--;
                }

                ///cout << Add[get<2>(Points[i])] << '\n';
            }
        }
    }

     for(int i = 1; i <= Q; i++)
     {
         int left = Questions[i].first + 1, right = Questions[i].second;
         cout << Query(left, right, i) << '\n';
     }
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}
