#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e6 + 1;
int N, Q, G;
string S;
int Prefix[MAXN];
int Active[MAXN];
vector<pair<int, int>> Edges;

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> Q >> G;
    cin >> S;

    stack<int> St;

    for(int i = 0; i < (int)S.size(); i++)
    {
        if(S[i] =='(')
        {
            St.push(i);
            Prefix[i + 1]++;
        }
        else
        {
            if(!St.empty() && S[St.top()] == '(')
            {
                Edges.push_back({i + 1, St.top() + 1});
                Prefix[i + 1]--;
                St.pop();
            }
            else
            {
                St.push(i);
            }
        }
    }

    sort(Edges.begin(), Edges.end());
    reverse(Edges.begin(), Edges.end());

    for(int i = 1; i <= (int)S.size(); i++)
    {
        Prefix[i] += Prefix[i - 1];
    }
}

int Query(int left, int right)
{
    int Size = Prefix[right] - Prefix[left - 1];

    for(auto& V : Edges)
    {
        if(V.first < left)
        {
            break;
        }

        if(V.first <= right && V.second < left)
        {
            Size++;
        }
    }

    int Ans = Size / 2;

    if(Size % 2 != 0)
    {
        Ans++;
    }

    return Ans;
}

void Solve()
{
     while(Q--)
     {
         int left, right; cin >> left >> right;
         cout << Query(left, right) << '\n';
     }
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}
