#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5 + 1;
const int MAXM = 1e6 + 1;
int N, Q;
vector<pair<int, int>> Graph[MAXN];
vector<tuple<int, int, int>> Edges;
vector<pair<int, int>> Queries;
vector<int> Weigths;
unordered_map<int, int> Hash;
int Data = 0;
int Value[2 * MAXN];
int Counter[2 * MAXN];
long long Prefix[2 * MAXN];
int Visited[MAXN];
int Mark;

void FastEJOI() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read() {
    cin >> N >> Q;

    for(int i = 1; i < N; i++) {
        int U, V, W;
        cin >> U >> V >> W;
        Edges.push_back({U, V, W});
        Weigths.push_back(W);
    }

    for(int i = 0; i < Q; i++) {
        int left, right;
        cin >> left >> right;
        Queries.push_back({left, right});
        Weigths.push_back(left);
        Weigths.push_back(right);
    }

    sort(Weigths.begin(), Weigths.end());

    for(auto& W : Weigths) {
        if(Hash[W] == 0) {
            Data++;
            Hash[W] = Data;
            Value[Data] = W;
        }
    }

    for(int i = 0; i < N - 1; i++) {
        int U, V, W;
        tie(U, V, W) = Edges[i];
        W = Hash[W];

        Graph[U].push_back({V, W});
        Graph[V].push_back({U, W});
    }
}

void Dfs(int U, int W, int S) {

    Visited[U] = Mark;

    for(auto& V : Graph[U]) {
        int NewW = max(W, V.second);

        if(Visited[V.first] == Mark)
        {
            continue;
        }

        if(S < V.first) {
            Counter[NewW]++;
        }

        Dfs(V.first, NewW, S);
    }
}

void Do_Prefix() {

    for(int U = 1; U <= N; U++) {
        Mark++;
        Dfs(U, 0, U);
    }

    for(int i = 1; i < 2* MAXN; i++) {
        Prefix[i] = Prefix[i - 1] + Counter[i] * Value[i];
    }
}

void Solve() {
    for(int i = 0; i < Q; i++) {
        int left, right;
        tie(left, right) = Queries[i];
        left = Hash[left];
        right = Hash[right];
        cout << Prefix[right] - Prefix[left - 1] << '\n';
    }
}

int main() {
    FastEJOI();
    Read();
    Do_Prefix();
    Solve();
    return 0;
}
