#include <bits/stdc++.h>
using namespace std;

const int MAXN = 50 + 1;
const int MAXM = 1e6 + 1;
int N, Q;
vector<pair<int, long long>> Graph[MAXN];
vector<tuple<int, int, long long>> Edges;
vector<pair<int, int>> Queries;
vector<long long> Weigths;
unordered_map<long long, int> Hash;
int Data = 0;
long long Value[2 * MAXN];
long long Counter[2 * MAXN];
long long Prefix[2 * MAXN];
int Visited[MAXN];
int Mark;
bool Counted[MAXN][MAXN];

void FastEJOI() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read() {
    cin >> N >> Q;

    for(int i = 0; i < N - 1; i++) {
        int U, V, W;
        cin >> U >> V >> W;
        Edges.push_back({U, V, W});
        Weigths.push_back(W);
    }

    for(int i = 0; i < Q; i++) {
        int left, right;
        cin >> left >> right;
        Queries.push_back({left, right});
        Weigths.push_back(left);
        Weigths.push_back(right);
    }

    sort(Weigths.begin(), Weigths.end());

    for(auto& W : Weigths) {
        if(Hash[W] == 0) {
            Data++;
            Hash[W] = Data;
            Value[Data] = W;
        }
    }

    for(int i = 0; i < Edges.size(); i++) {
        int U, V, W;
        tie(U, V, W) = Edges[i];
        W = Hash[W];

        Graph[U].push_back({V, W});
        Graph[V].push_back({U, W});
    }
}

void Dfs(int U, long long W, int S) {
    if(Visited[U] == Mark) {
        return;
    }

    if(!Counted[U][S])
    {
        Counter[W]++;
        Counted[U][S] = true;
        Counted[S][U] = true;
    }

    Visited[U] = Mark;

    for(auto& V : Graph[U]) {
        int NewW = max(W, V.second);
        Dfs(V.first, NewW, S);
    }
}

void Do_Prefix() {

    for(int U = 1; U <= N; U++) {
        Mark++;
        Dfs(U, 0, U);
    }

    for(int i = 1; i <= N + Q; i++) {
        Prefix[i] = Prefix[i - 1] + Counter[i] * Value[i];
    }
}

void Solve() {
    for(int i = 0; i < Q; i++) {
        int left, right;
        tie(left, right) = Queries[i];
        left = Hash[left];
        right = Hash[right];
        cout << Prefix[right] - Prefix[left - 1] << '\n';
    }
}

int main() {
    FastEJOI();
    Read();
    Do_Prefix();
    Solve();
    return 0;
}
