# include <iostream>
# include <vector>
using namespace std;

const int MAX=1e3+11,LOG=11;
vector<pair<int, int>> a[MAX];
int st[MAX][LOG];
int d[MAX][LOG];
int h[MAX];
int n,q;

void dfs(int curr, int p)
{
    for(pair<int, int> nxt: a[curr])
    {
        if(nxt.first==p) continue;

        h[nxt.first]=h[curr]+1;
        d[nxt.first][0]=nxt.second;
        st[nxt.first][0]=curr;
        dfs(nxt.first,curr);
    }
}

void lca_precomp()
{
    dfs(1,0);
    for(int j=1;j<LOG;j++)
    {
        for(int i=1;i<=n;i++)
        {
            if(h[i]-(1<<j)<0) continue;
            st[i][j]=st[st[i][j-1]][j-1];
            d[i][j]=max(d[i][j-1],d[st[i][j-1]][j-1]);
        }
    }
}

int lift(int u, int power)
{
    int ans=0;
    for(int i=LOG-1;i>=0;i--)
    {
        if(power-(1<<i)>=0)
        {
            power-=(1<<i);
            ans=max(ans,d[u][i]);
            u=st[u][i];
        }
    }

    return ans;
}

int get_lca(int u, int v)
{
    if(h[u]<h[v]) swap(u,v);

    for(int i=LOG-1;i>=0;i--)
    {
        if(h[u]-(1<<i)>=h[v]) u=st[u][i];
    }

    if(u==v) return u;
    for(int i=LOG-1;i>=0;i--)
    {
        if(h[u]-(1<<i)>=0 and st[u][i]!=st[v][i])
        {
            u=st[u][i];
            v=st[v][i];
        }
    }

    return st[u][0];
}

int get_dist(int u, int v)
{
    int lca=get_lca(u,v);
    return max(lift(u,h[u]-h[lca]),lift(v,h[v]-h[lca]));
}

int dist[MAX][MAX];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>q;
    for(int i=1;i<n;i++)
    {
        int x,y,w;
        cin>>x>>y>>w;

        a[x].push_back({y,w});
        a[y].push_back({x,w});
    }

    lca_precomp();
    for(int i=1;i<=n;i++)
    {
        for(int j=i+1;j<=n;j++)
        {
            dist[i][j]=get_dist(i,j);
        }
    }

    while(q--)
    {
        int l,r;
        cin>>l>>r;

        long long ans=0;
        for(int i=1;i<=n;i++)
        {
            for(int j=i+1;j<=n;j++)
            {
                int curr=dist[i][j];
                if(l<=curr and curr<=r) ans+=curr;
            }
        }

        cout<<ans<<"\n";
    }

    return 0;
}
