# include <iostream>
# include <algorithm>
# include <vector>
using namespace std;

struct edge
{
    int u, v;
    long long c;
};

struct query
{
    int l,r,id;
};

const int MAX=1e5+11;
edge a[MAX];
vector<query> z;
long long ans[MAX];
int n,q;

bool cmp(edge p, edge q)
{
    return p.c<q.c;
}

bool cmp2(query p, query q)
{
    return p.r<q.r;
}

long long curr=0;
int p[MAX];
int sz[MAX];

int root(int u)
{
    if(p[u]==u) return u;
    return root(p[u]);
}

void Union(int u, int v, long long c)
{
    u=root(u);
    v=root(v);

    if(sz[u]<sz[v]) swap(u,v);
    curr+=(long long)c*sz[u]*sz[v];

    p[v]=u;
    sz[u]+=sz[v];
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>q;
    for(int i=1;i<n;i++)
    {
        cin>>a[i].u>>a[i].v>>a[i].c;
    }

    sort(a+1,a+n,cmp);
    for(int i=1;i<=n;i++)
    {
        sz[i]=1;
        p[i]=i;
    }

    for(int i=1;i<=q;i++)
    {
        int l,r;
        cin>>l>>r;

        z.push_back({1,l-1,-i});
        z.push_back({1,r,i});
    }

    sort(z.begin(),z.end(),cmp2);

    int id=1;
    for(int i=0;i<q*2;i++)
    {
        //cout<<"->"<<z[i].r<<" "<<z[i].id<<"\n";
        while(id<n and a[id].c<=z[i].r)
        {
            edge e=a[id];
            id++;

            if(root(e.u)==root(e.v)) continue;

            Union(e.u,e.v,e.c);
        }

        if(z[i].id<0) ans[-z[i].id]-=curr;
        else ans[z[i].id]+=curr;
    }

    for(int i=1;i<=q;i++) cout<<ans[i]<<"\n";

    return 0;
}
/*
7 4
1 2 1
3 1 3
1 4 1
4 5 2
5 7 4
3 6 2
1 1
1 2
1 3
1 4
*/
