#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

constexpr int MAX_LOG = 19, MAX_N = 524288;

struct SparseTable {
    vector<vector<int>> sp;
    SparseTable(vector<int> a) {
        a.resize(MAX_N, 0);
        sp.resize(MAX_LOG + 1, vector<int>(MAX_N));
        sp[0] = a;
        for (int i = 1; i <= MAX_LOG; ++i) {
            for (int j = 0; j + (1 << i) <= MAX_N; ++j) {
                sp[i][j] = min(sp[i - 1][j], sp[i - 1][j + (1 << (i - 1))]);
            }
        }
    }
    int query(int l, int r) {
        int i = __lg(r - l);
        return min(sp[i][l], sp[i][r - (1 << i)]);
    }
};

signed main() {
    int n, q, g;
    cin >> n >> q >> g;
    string s;
    cin >> s;
    vector<int> a(2 * n + 1);
    for (int i = 0; i < 2 * n; ++i) {
        a[i + 1] = a[i] + (s[i] == '(' ? 1 : -1);
    }
    SparseTable st{a};
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        cout << max(0, (-(st.query(l, r + 1) - a[l - 1]) + 1) / 2) << "\n";
    }
}
