#include <bits/stdc++.h>
using namespace std;

struct DSU {
    vector<int> p, sz;
    DSU(int n) {
        p.resize(n);
        sz.resize(n, 1);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
    }
    int parent(int u) {
        if (u != p[u]) {
            p[u] = parent(p[u]);
        }
        return p[u];
    }
    bool unite(int u, int v) {
        u = parent(u);
        v = parent(v);
        if (u == v) {
            return false;
        }
        if (sz[u] < sz[v]) {
            swap(u, v);
        }
        // Now sz[u] > sz[v] and u will be parent of v.
        p[v] = u;
        sz[u] += sz[v];
        return true;
    }
};

int main() {
    int n, q;
    cin >> n >> q;
    vector<tuple<int, int, int, int>> all(n - 1 + 2 * q);
    for (int i = 0; i < n - 1; ++i) {
        int w, u, v;
        cin >> u >> v >> w;
        all[i] = {w, -2, u - 1, v - 1};
    }
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        all[n - 1 + 2 * i] = {l - 1, -1, i, -1};
        all[n - 1 + 2 * i + 1] = {r, 1, i, -1};
    }
    sort(all.begin(), all.end());
    vector<long long> ans(q);
    DSU tre{n};
    long long cur = 0;
    for (auto [tm, tp, u, v] : all) {
        if (tp == -2) {
            int uParSz = tre.sz[tre.parent(u)], vParSz = tre.sz[tre.parent(v)];
            cur += 1LL * uParSz * vParSz * tm;
            tre.unite(u, v);
        } else {
            ans[u] += tp * cur;
        }
    }
    for (long long el : ans) {
        cout << el << "\n";
    }
}
