#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

#ifdef LOC
#define debug(x) cout<<#x<<" = "<<x<<'\n'
#else
#define debug(x)
#endif
struct SegTree {
    int n;
    vector<int> t, v;
    SegTree(vector<int> v_): v(v_) {
        n = v.size();
        t.assign(4 * n + 10, 0);
        build(0, 0, n);
    }

    void build(int i, int l, int r) {
        if (l + 1 == r) {
            t[i] = v[l];
            return;
        }
        int mid = (l + r) / 2;
        build(i * 2 + 1, l, mid);
        build(i * 2 + 2, mid, r);
        t[i] = min(t[i * 2 + 1], t[i * 2 + 2]);
    }

    int get(int i, int l, int r, int ql, int qr) {
        // debug(l << " " << r);
        if (qr <= l || r <= ql)
            return INF;
        if (ql <= l && r <= qr) {
            return t[i];
        }

        int mid = (l + r) / 2;
        return min(
            get(i * 2 + 1, l, mid, ql, qr),
            get(i * 2 + 2, mid, r, ql, qr)
        );
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};

void solve() {
    int n, q, p;
    cin >> n >> q >> p;
    n *= 2;
    vector<int> v(n);
    for (auto& i : v) {
        char ch;
        cin >> ch;
        if (ch == '(')
            i = 1;
        else
            i = -1;
    }
    vector<int> dp(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        dp[i + 1] = dp[i] + v[i];
    }

    SegTree st(dp);

    for (int qq = 0; qq < q; ++qq) {
        int l, r;
        cin >> l >> r;
        l--;
        int mn = st.get(l + 1, r + 1);
        mn -= dp[l];
        debug(mn);
        cout << (abs(mn) + 1) / 2 << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q = 1;
#ifdef LOC
    cin >> q;
#endif
    for (int i = 0; i < q; ++i)
        solve();
}