#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll INF = 1e9;

#ifdef LOC
#define debug(x) cout<<#x<<" = "<<x<<'\n'
#else
#define debug(x)
#endif

const ll N = 1e5;
mt19937 rng(3232);

struct S {
    ll n;
    vector<ll> p;
    S(ll n_): n(n_) {
        p.assign(n, -1);
    }

    ll par(ll v) {
        if (p[v] == -1) return v;
        return p[v] = par(p[v]);
    }

    ll unite(ll a, ll b) {
        if (rng() & 1)
            swap(a, b);
        if (par(a) == par(b))
            assert(par(par(a) != par(b)));
        p[par(a)] = par(b);
        return par(b);
    }
};

void solve() {
    ll n, q;
    cin >> n >> q;
    ll m = n - 1;
    vector<pair<ll, pair<ll, ll>>> ee;
    vector<ll> ws;
    for (ll i = 0; i < m; ++i)
    {
        ll v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        ee.push_back({w, {v, u}});
        ws.push_back(w);
    }

    sort(ws.begin(), ws.end());
    ws.resize(unique(ws.begin(), ws.end()) - ws.begin());
    map<ll, ll> mp;
    for (ll i = 0; i < ws.size(); ++i) {
        mp[ws[i]] = i;
    }

    vector<vector<pair<ll, ll>>> e(N);

    for (ll i = 0; i < m; ++i) {
        auto [w, vu] = ee[i];
        e[mp[w]].push_back(vu);
    }

    S s(n);
    vector<ll> val(n, 1);
    vector<ll> rs(ws.size(), 0);
    ll ans = 0;
    ll ansp = 0;
    for (ll i = 0; i < ws.size(); ++i)
    {
        for (auto [v, u] : e[i]) {
            v = s.par(v);
            u = s.par(u);
            ans -= val[v] * (val[v] - 1) / 2;
            ans -= val[u] * (val[u] - 1) / 2;
            ll r = s.unite(v, u);
            ll ns = val[v] + val[u];
            ans += ns * (ns - 1) / 2;
            val[r] = ns;
        }


        rs[i] = rs[i - 1] + (ans - ansp) * ws[i];
        ansp = ans;
    }

    for (ll i = 0; i < q; ++i) {
        ll l, r;
        cin >> l >> r;
        l = lower_bound(ws.begin(), ws.end(), l) - ws.begin();
        r = upper_bound(ws.begin(), ws.end(), r) - ws.begin() - 1;
        if (r < l) {
            cout << "0\n";
            continue;
        }
        debug(rs[r]);
        cout << rs[r] - (l > 0 ? rs[l - 1] : 0) << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll q = 1;
#ifdef LOC
    cin >> q;
#endif
    for (ll i = 0; i < q; ++i)
        solve();
}