#include <iostream>
#include<string>
#include<cmath>
#include<map>
#include<iomanip>
#include<algorithm>
#include<vector>
#include<set>
#include<cstdio>
#include<stack>
#include<ctime>
#include<queue>
#include<deque>
#include<bitset>
#include<random>
#include<fstream>
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}
struct dsu {
    vector<int> p, r, sz;
    dsu(int n) {
        p.resize(n);
        r.resize(n);
        sz.resize(n);
        for (int i = 0; i < n; ++i) p[i] = i, sz[i] = 1;
    }
    int pr(int v) {
        return p[v] = p[v] == v ? v : pr(p[v]);
    }
    void unite(int x, int y) {
        x = pr(x), y = pr(y);
        if (r[y] > r[x]) swap(x, y);
        sz[x] += sz[y];
        r[x] += r[x] == r[y];
        p[y] = x;
    }
    int size(int v) {
        return sz[pr(v)];
    }
};
struct edge {
    int x, y, w;
};
bool cmp(edge a, edge b) {
    return a.w < b.w;
}


void solve() {
    int n, q;
    cin >> n >> q;
    vector<edge> a(n - 1);
    for (auto& i : a) cin >> i.x >> i.y >> i.w, i.x--, i.y--;
    sort(a.begin(), a.end(), cmp);
    dsu d(n);
    vector<pair<int, ll>> pr;
    pr.push_back({ -1, 0 });
    for (auto &r : a) {
        int x = r.x, y = r.y, w = r.w;
        if (w != pr.back().first) pr.push_back({ w, pr.back().second });
        pr.back().second += 1ll * d.size(x) * d.size(y) * w;
        d.unite(x, y);
    }
    while (q--) {
        int ql, qr;
        cin >> ql >> qr;
        ll ans = 0;
        int l = -1, r = n;
        while (r - l > 1) {
            int x = (l + r) >> 1;
            if (x >= pr.size() || pr[x].first >= ql) r = x;
            else l = x;
        }
        if (l != -1) ans -= pr[l].second;
        l = -1, r = n;
        while (r - l > 1) {
            int x = (l + r) >> 1;
            if (x >= pr.size() || pr[x].first > qr) r = x;
            else l = x;
        }
        if (l != -1) ans += pr[l].second;
        cout << ans << '\n';
    }
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("coloring.in", "r", stdin);
    //freopen("coloring.out", "w", stdout);

    //ld time1 = clock();

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
        cout.flush();
    }

    //ld time2 = clock();
    //cerr << "\n\nTIME: " << (time2 - time1) / CLOCKS_PER_SEC;
    return 0;
}