#include <iostream>
#include<string>
#include<cmath>
#include<map>
#include<iomanip>
#include<algorithm>
#include<vector>
#include<set>
#include<cstdio>
#include<stack>
#include<ctime>
#include<queue>
#include<deque>
#include<bitset>
#include<random>
#include<fstream>
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}
bool dfs(int v, int x, int y, int st, int len, int h) {
    if (v == st && h) return false;
    if (v + y <= len) return dfs(v + y, x, y, st, len, h + 1);
    else if (v - x >= 0) return dfs(v - x, x, y, st, len, h + 1);
    else return true;
}
bool check(int v, int x, int y) {
    return dfs(v, x, y, v, v, 0);
}
int get(int x, int y) {
    int l = 0, r = x + y;
    while (r - l > 1) {
        int m = (l + r) >> 1;
        if (check(m, x, y)) {
            l = m;
        }
        else {
            r = m;
        }
    }
    return l;
}
vector<int> ts;
vector<bool> used;
void topsort(int v, int len, int x, int y) {
    used[v] = true;
    if (v >= x && !used[v - x]) topsort(v - x, len, x, y);
    else if (v + y <= len && !used[v + y]) topsort(v + y, len, x, y);
    ts.push_back(v);
}

void solve() {
    int q;
    cin >> q;
    --q;
    int x, y;
    cin >> x >> y;
    vector<ll> ans;
    bool f = x > y;
    if (x > y) swap(x, y);
    
    if (y % x == 0) {
        ans.resize(y - 1);
        if(y - 1) fill(ans.begin(), ans.end(), 1);
    }
    else {
        int len = x + y - 1 - gcd(x, y);
        ans.resize(len);
        vector<int> psum(len + 1);
        used.resize(len + 1);
        for (int i = 0; i <= len; ++i) {
            if (!used[i]) topsort(i, len, x, y);
        }
        reverse(ts.begin(), ts.end());
        int pos0 = -1;
        for (int i = 0; i <= len; ++i) if (ts[i] == 0) pos0 = i;
        for (int i = 0; i <= len; ++i) {
            psum[ts[i]] = pos0 - i;
        }
        for (int i = 0; i < len; ++i) {
            ans[i] = psum[i + 1] - psum[i];
        }
    }

    if (f) {
        for (auto& i : ans) i *= -1;
    }
    cout << ans.size() << ' ';
    while (q--) {
        int x, y;
        cin >> x >> y;
        if (x > y) swap(x, y);
        if (y % x == 0) {
            cout << y - 1 << ' ';
            continue;
        }
        cout << x + y - 1 - gcd(x, y) << ' ';
    }
    cout << '\n';
    if (f) swap(x, y);
    vector<ll> psum(ans.size() + 1);
    for (int i = 0; i < ans.size(); ++i) {
        psum[i + 1] = psum[i] + ans[i];
    }
    for (int l = 0; l + x <= ans.size(); ++l) {
        if (psum[l + x] - psum[l] <= 0) {
            cout << "Not pol " << l + 1 << ' ' << l + x << '\n';
        }
    }
    for (int l = 0; l + y <= ans.size(); ++l) {
        if (psum[l + y] - psum[l] >= 0) {
            cout << "Not otr " << l + 1 << ' ' << l + x << '\n';
        }
    }
    for (auto i : ans) cout << i << ' ';
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("coloring.in", "r", stdin);
    //freopen("coloring.out", "w", stdout);

    //ld time1 = clock();

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
        cout.flush();
    }

    //ld time2 = clock();
    //cerr << "\n\nTIME: " << (time2 - time1) / CLOCKS_PER_SEC;
    return 0;
}