#include<algorithm>
#include<iostream>
#include<vector>
#include<map>
using namespace std;

vector<long long> p, sz;

long long get(long long v) {
	if (v == p[v]) {
		return v;
	}
	return p[v] = get(p[v]);
}

long long unite(long long a, long long b) {
	a = get(a);
	b = get(b);
	long long cnt = sz[a] * sz[b];
	if (sz[a] > sz[b]) {
		swap(a, b);
	}
	p[a] = b;
	sz[b] += sz[a];
	return cnt;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, q;
	cin >> n >> q;
	p.resize(n);
	sz.resize(n, 1);
	for (long long i = 0; i < n; i++) {
		p[i] = i;
	}
	vector<pair<long long, pair<long long, long long>>> E;
	for (int i = 0; i < n - 1; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--;
		v--;
		E.push_back({w, {u, v}});
	}
	sort(E.begin(), E.end());
	


	vector<long long> ans(q);
	vector<pair<long long, long long>> events_minus, events_plus;
	for (long long i = 0; i < q; i++) {
		long long l, r;
		cin >> l >> r;
		events_minus.push_back({l, i});
		events_plus.push_back({r, i});
	}
	sort(events_minus.begin(), events_minus.end());
	sort(events_plus.begin(), events_plus.end());
	long long summ = 0, minius = 0, plus = 0;
	for (long long i = 0; i < n - 1; i++) {
		while (minius < (long long) events_minus.size() && events_minus[minius].first <= E[i].first && (i == 0 || E[i - 1].first != E[i].first)) {
			ans[events_minus[minius].second] -= summ;
			minius++;
		}
		summ += unite(E[i].second.first, E[i].second.second) * E[i].first;


		while (plus < (long long) events_plus.size() && events_plus[plus].first <= E[i].first && (i == n - 2 || E[i + 1].first != E[i].first)) {
			ans[events_plus[plus].second] += summ;
			plus++;
		}
	}
	while (plus < (long long) events_plus.size()) {
		ans[events_plus[plus].second] += summ;
		plus++;
	}
	for (auto &i : ans) {
		cout << i << endl;
	}
}