#include<algorithm>
#include<iostream>
#include<vector>
#include<map>
using namespace std;

vector<int> p;
vector<long long> sz;

int get(int v) {
	if (v == p[v]) {
		return v;
	}
	return p[v] = get(p[v]);
}

long long unite(int a, int b) {
	a = get(a);
	b = get(b);
	long long cnt = sz[a] * sz[b];
	if (sz[a] > sz[b]) {
		swap(a, b);
	}
	p[a] = b;
	sz[b] += sz[a];
	return cnt;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, q;
	cin >> n >> q;
	p.resize(n);
	sz.resize(n, 1);
	for (int i = 0; i < n; i++) {
		p[i] = i;
	}
	vector<pair<long long, pair<int, int>>> E;
	for (int i = 0; i < n - 1; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--;
		v--;
		E.push_back({w, {u, v}});
	}
	sort(E.begin(), E.end());
	


	vector<long long> ans(q);
	vector<pair<int, int>> events_minus, events_plus;
	for (int i = 0; i < q; i++) {
		int l, r;
		cin >> l >> r;
		events_minus.push_back({l, i});
		events_plus.push_back({r, i});
	}
	sort(events_minus.begin(), events_minus.end());
	sort(events_plus.begin(), events_plus.end());
	int minus = 0, plus = 0;
	long long summ = 0;
	for (int i = 0; i < n - 1; i++) {
		while (minus < (int) events_minus.size() && events_minus[minus].first <= E[i].first && (i == 0 || E[i - 1].first != E[i].first)) {
			ans[events_minus[minus].second] -= summ;
			minus++;
		}

		while (plus < (int) events_plus.size() && events_plus[plus].first < E[i].first && (i == 0 || E[i - 1].first != E[i].first)) {
			ans[events_plus[plus].second] += summ;
			plus++;
		}

		summ += unite(E[i].second.first, E[i].second.second) * E[i].first;

	}
	while (plus < (int) events_plus.size()) {
		ans[events_plus[plus].second] += summ;
		plus++;
	}


	while (minus < (int) events_minus.size()) {
		ans[events_minus[minus].second] -= summ;
		minus++;
	}
	for (auto &i : ans) {
		cout << i << '\n';
	}
}