#include <bits/stdc++.h>
#define int int64_t

using namespace std;

bool check(const string& s) {
    int brackets = 0;

    for (const char& c : s) {
		if (c == '(')
			++brackets;
		else {
			if (brackets == 0)
				return false;

			--brackets;
		}
    }

    return brackets == 0;
}

int brute_force(string s, const vector<int>& opened, const vector<int>& closed, int i = 0, int answer = 0) {
	if (check(s))
		return answer;
	if (i >= opened.size())
		return opened.size();

	int result = opened.size();

	for (int j = 0; j < closed.size(); ++j) {
		swap(s[opened[i]], s[closed[j]]);
		result = min(result, brute_force(s, opened, closed, i + 1, answer + 1));
		swap(s[opened[i]], s[closed[j]]);
	}

	return result;
}

int32_t main()
{
    int n, q, g;
    string s;
    cin >> n >> q >> g;
    cin >> s;

    while (q--) {
        int l, r;
        cin >> l >> r;
        vector<int> opened;
        vector<int> closed;
        stack<int> brackets;

        --l;
        --r;

        string sub = s.substr(l, r - l + 1);

        for (int i = 0; i < sub.size(); ++i) {
            if (sub[i] == '(')
                brackets.push(i);
            else if (brackets.empty())
                closed.push_back(i);
			else
				brackets.pop();
        }

		while (!brackets.empty()) {
			opened.push_back(brackets.top());
			brackets.pop();
		}

		cout << brute_force(sub, opened, closed) << "\n";
    }
}
