#include <bits/stdc++.h>
#define int unsigned long long

using namespace std;

struct Node {
    Node(int next, int weight) {
        this->next = next;
        this->weight = weight;
    }

    int next;
    int weight;
};

void dfs(vector<vector<Node>>& graph, vector<int>& ways, vector<bool>& used, int start, int current, int maximum = 1) {
    if (current > start)
        ways.push_back(maximum);

    used[current] = true;

    for (Node& neighbour : graph[current]) {
        if (!used[neighbour.next])
            dfs(graph, ways, used, start, neighbour.next, max(maximum, neighbour.weight));

    }
}

int32_t main()
{
    int n, q;
    cin >> n >> q;
    vector<vector<Node>> graph(n + 1);
    vector<int> ways;

    for (int i = 1; i < n; ++i) {
        int u, v, w;
        cin >> u >> v >> w;

        graph[u].push_back(Node(v, w));
        graph[v].push_back(Node(u, w));
    }

    for (int i = 1; i <= n; ++i) {
        vector<bool> used(n + 1, false);
        dfs(graph, ways, used, i, i);
    }

    sort(ways.begin(), ways.end());

    vector<int> pref(ways.size());

    pref[0] = ways[0];

    for (int i = 1; i < ways.size(); ++i)
        pref[i] = pref[i - 1] + ways[i];

    while (q--) {
        int l, r;
        cin >> l >> r;
        int start;

        int left = 0, right = ways.size() - 1;

        while (left < right) {
            int mid = left + (right - left) / 2;

            if (ways[mid] < l)
                left = mid + 1;
            else
                right = mid;
        }

        start = right;

        left = 0, right = ways.size() - 1;

        while (left < right) {
            int mid = left + (right - left) / 2;

            if (ways[mid] <= r)
                left = mid + 1;
            else
                right = mid;
        }

        if (ways[right] > r)
            --right;

        cout << pref[right] - pref[start] + ways[start] << "\n";
    }
}
