#include <bits/stdc++.h>

using namespace std;

vector<int> a;
vector<vector<int>> tree;

void init(int n, int l, int r) {
    if (r - l == 1) {
        tree[n] = {a[l]};
        return;
    }

    int m = (l + r) / 2;
    init(2 * n + 1, l, m);
    init(2 * n + 2, m, r);

    int i1 = 0, i2 = 0;
    while (i1 < tree[2 * n + 1].size() && i2 < tree[2 * n + 2].size()) {
        if (tree[2 * n + 1][i1] == tree[2 * n + 2][i2]) {
            tree[n].push_back(tree[2 * n + 1][i1]);
            ++i1, ++i2;
        } else if (tree[2 * n + 1][i1] < tree[2 * n + 2][i2]) {
            tree[n].push_back(tree[2 * n + 1][i1++]);
        } else {
            tree[n].push_back(tree[2 * n + 2][i2++]);
        }
    }

    while (i2 < tree[2 * n + 2].size()) {
        tree[n].push_back(tree[2 * n + 2][i2++]);
    }

    while (i1 < tree[2 * n + 1].size()) {
        tree[n].push_back(tree[2 * n + 1][i1++]);
    }
}

int query(int n, int l, int r, int ql, int qr, int x) {
    if (ql <= l && r <= qr) {
        return lower_bound(tree[n].begin(), tree[n].end(), x) - tree[n].begin();
    }

    int m = (l + r) / 2, ans1 = 0, ans2 = 0;

    if (m > ql) ans1 = query(2 * n + 1, l, m, ql, qr, x);
    if (m < qr) ans2 = query(2 * n + 2, m, r, ql, qr, x - ans1);

    return ans1 + ans2;
}

void solve() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, q, g, l, r, cnt, x;
    cin >> n >> q >> g;

    string s;
    cin >> s;

    vector<int> close, all(2 * n);
    tree.assign(4 * n, {});

    int sm = 0;
    for (int i = 0; i < 2 * n; ++i) {
        if (s[i] == ')') {
            --sm;
        } else {
            ++sm;
        }

        if (s[i] == ')') {
            close.push_back(i);
            a.push_back(sm);
        }

        all[i] = sm;
    }

    init(0, 0, n);
    while (q--) {
        cin >> l >> r, --l, --r;

        if (l == 0) x = 0;
        else x = all[l - 1];

        l = lower_bound(close.begin(), close.end(), l) - close.begin();
        r = upper_bound(close.begin(), close.end(), r) - close.begin() - 1;

        cnt = query(0, 0, n, l, r + 1, x);

        cout << (cnt + 1) / 2 << "\n";
    }
}

signed main() {
    int tt = 1;

    while (tt--) {
        solve();
        cout << "\n";
    }
}