#include <bits/stdc++.h>

using namespace std;

vector<int> p, sz;
vector<pair<int, pair<int, int>>> edges;

int root(int x) {
    if (p[x] == x) return x;
    p[x] = root(p[x]);

    return p[x];
}

void merge(int a, int b) {
    a = root(a), b = root(b);

    if (a == b) return;

    if (sz[a] < sz[b]) swap(a, b);

    p[b] = a;
    sz[a] += sz[b];
}

void solve() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, q, u, v, x;
    cin >> n >> q;

    edges.resize(n - 1), p.resize(n), sz.resize(n, 1);
    for (int i = 0; i < n; ++i) p[i] = i;

    vector<int> ans(n - 1), c(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        cin >> u >> v >> x;

        edges[i] = {x, {u - 1, v - 1}};
        c[i] = x;
    }

    sort(edges.begin(), edges.end());
    sort(c.begin(), c.end());

    int idx = 0;
    for (auto el: edges) {
        x = el.first, u = el.second.first, v = el.second.second;

        u = root(u), v = root(v);
        ans[idx++] = sz[u] * sz[v] * x;

        merge(u, v);
    }

    for (int i = 1; i < n - 1; ++i) ans[i] += ans[i - 1];

    while (q--) {
        cin >> u >> v;
        int l = lower_bound(c.begin(), c.end(), u) - c.begin(),
        r = lower_bound(c.begin(), c.end(), v) - c.begin();

        r = min(r, n - 2);

        if (l == 0) cout << ans[r] << "\n";
        else cout << ans[r] - ans[l - 1] << "\n";
    }
}

signed main() {
    int tt = 1;

    while (tt--) {
        solve();
        cout << "\n";
    }
}