#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using vll = vector<ll>;

ll const INF = 1e18;

struct tr {
	ll l, r, mid, val;
	tr* lp = nullptr, * rp = nullptr;
	tr(ll l, ll r, vll& arr) : l(l), r(r), mid((l + r) / 2) {
		if (l == r) {
			val = arr[l];
			return;
		}
		lp = new tr(l, mid, arr);
		rp = new tr(mid + 1, r, arr);
		val = min(lp->val, rp->val);
	}
	ll query(ll f, ll t) {
		//cout << "l = " << l << " r = " << r << " mid = " << mid << endl;
		if (f > r || t < l) {
			return INF;
		}
		if (f <= l && t >= r) {
			return val;
		}
		return min(lp->query(f, t), rp->query(f, t));
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll n, q, g;
	cin >> n >> q >> g;
	n *= 2;
	string s;
	cin >> s;
	// Build the prefix array and the minimum st
	vll pref(n);
	pref[0] = -1;
	if (s[0] == '(') {
		pref[0] = 1;
	}
	vll arr(n);
	for (ll i = 1; i < n; i++) {
		if (s[i] == '(') arr[i] = 1;
		else arr[i] = -1;
		pref[i] = pref[i - 1] + arr[i];
	}
	tr seg(0, n - 1, pref);
	//cout << seg.query(0, 1) << endl;
	//cout << seg.query(0, 2) << endl;
	//cout << seg.query(2, 4) << endl;
	//cout << seg.query(1, 2) << endl;
	while (q--) {
		ll l, r;
		cin >> l >> r;
		l--, r--;
		if (l == 0) {
			if ((seg.query(l, r) >= 0) && (pref[r] == 0)) {
				cout << "0" << endl;
				continue;
			}
			cout << "1" << endl;
		}
		else if ((seg.query(l, r) - pref[l - 1] >= 0) && (pref[r] - pref[l - 1] == 0)) {
			cout << "0" << endl;
		}
		else {
			cout << "1" << endl;
		}
		continue;


		/*
		ll j = n - 1;
		while (arr[j] != 1) {
			j--;
		}
		ll add = 0;
		ll ans = 0;
		for (ll i = 0; i < n; i++) {
			if (i >= j) {
				break;
			}
			if (pref[i] + add < 0) {
				ans++;
				add += 2;
				j--;
				while (j >= i && arr[j] != 1) {
					j--;
				}
			}
		}
		cout << ans << endl;*/
	}
}