#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;

#define int long long

template<class t> using ordered_set =
        __gnu_pbds::tree<t, __gnu_pbds::null_type, less<t>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<class t> using ordered_multiset =
        __gnu_pbds::tree<t, __gnu_pbds::null_type, less_equal<t>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<class t, class u>
bool chmin(t &a, u b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<class t, class u>
bool chmax(t &a, u b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int mod = 1e9 + 7;

int binpow(int n, int e){
    int res = 1;
    while(e){
        if(e & 1) res = (res * n) % mod;
        n = (n * n) % mod;
        e >>= 1;
    }
    return res;
}

int divide(int a, int b){
    return a * binpow(b, mod - 2) % mod;
}

const int N = 2e5 + 5;

class segtree {
    vector<int> tree, a;
    int n;
    void build(int v, int tl, int tr) {
        if (tl == tr) {
            tree[v] = a[tl];
            return;
        }
        int tm = tl + tr >> 1;
        build(v << 1, tl, tm);
        build(v << 1 | 1, tm + 1, tr);
        tree[v] = max(tree[v << 1], tree[v << 1 | 1]);
    }
    int ans(int v, int tl, int tr, int l, int r) {
        if (tr < l || r < tl) return -1e18;
        if (l <= tl && tr <= r) return tree[v];
        int tm = tl + tr >> 1;
        return max(ans(v << 1, tl, tm, l, r), ans(v << 1 | 1, tm + 1, tr, l, r));
    }
public:
    segtree(vector<int> a, int n) {
        this->n = n;
        this->a = a;
        tree.assign((n + 1) << 2, 0);
        build(1, 1, n);
    }
    int calc(int l, int r) {
        return ans(1, 1, n, l, r);
    }
};

void solve() {
    int n, q, g;
    cin >> n >> q >> g;
    vector<int> pref((n * 2) + 1), a((n * 2) + 1);
    for (int i = 1; i <= n * 2; ++i) {
        char c;
        cin >> c;
        if (c == ')') {
            a[i] = 1;
        } else {
            a[i] = -1;
        }
        pref[i] = pref[i - 1] + a[i];
    }
    segtree tree(pref, n * 2);
    while (q--) {
        int l, r;
        cin >> l >> r;
        cout << (int)ceil((tree.calc(l, r) - pref[l - 1]) / 2.0) << '\n';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
//  int tt; cin >> tt; while(tt--) // DON'T FORGET
    solve();
}