#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;

#define int long long

template<class t> using ordered_set =
        __gnu_pbds::tree<t, __gnu_pbds::null_type, less<t>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<class t> using ordered_multiset =
        __gnu_pbds::tree<t, __gnu_pbds::null_type, less_equal<t>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<class t, class u>
bool chmin(t &a, u b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<class t, class u>
bool chmax(t &a, u b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int mod = 1e9 + 7;

int binpow(int n, int e){
    int res = 1;
    while(e){
        if(e & 1) res = (res * n) % mod;
        n = (n * n) % mod;
        e >>= 1;
    }
    return res;
}

int divide(int a, int b){
    return a * binpow(b, mod - 2) % mod;
}

void solve() {
    int n, q;
    cin >> n >> q;
    map<int, int> dp;
    vector<vector<pair<int, int> > > g(n + 1);
    vector<int> pref(n + 1);
    for (int i = 1; i < n; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].emplace_back(pair{v, w});
        g[v].emplace_back(pair{u, w});
    }
    vector<bool> used;
    function<void(int, int)> dfs = [&](int v, int mx) {
        used[v] = true;
        dp[mx]++;
        for (auto [to, weight]: g[v]) {
            if (!used[to]) dfs(to, max(mx, weight));
        }
    };
    for (int i = 1; i <= n; ++i) {
        used.assign(n + 1, false);
        dfs(i, 0);
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        int res = 0;
        for (auto [key, val]: dp) {
            if (key >= l && key <= r) {
                res += (val / 2) * key;
            } else if (key > r) break;
        }
        cout << res << '\n';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
//  int tt; cin >> tt; while(tt--) // DON'T FORGET
    solve();
}