#include <bits/stdc++.h>
#define int long long
#define all(x) x.begin(), x.end()
#define ff first
#define ss second

using namespace std;

class SegTree {
private:
    vector<int> t;
    vector<int> pref;
    vector<pair<int, int> > pref2;
    string s;
    int n;

    void build_pref() {
        for (int i = 0; i < n; i++) {
            if (i != 0) {
                pref[i] = pref[i - 1];
                pref2[i] = pref2[i - 1];
            }
            if (s[i] == '(') {
                pref[i]++;
                pref2[i].ff++;
            } else {
                pref[i]--;
                pref2[i].ss++;
            }
        }
    }

    void build(int v, int lx, int rx) {
        if (lx == rx) {
            t[v] = pref[lx];
        } else {
            int mx = (lx + rx) / 2;
            build(2*v, lx, mx);
            build(2*v + 1, mx+1, rx);
            t[v] = min(t[2*v], t[2*v+1]);
        }
    }

    int get(int v, int lx, int rx, int l, int r) {
        if (lx > r or rx < l) return 1e9;
        if (lx >= l and rx <= r) {
            int p1 = ((l == 0) ? 0 : pref2[l - 1].ff - pref2[l - 1].ss);
            return t[v] - p1;
        }
        int mx = (lx + rx) / 2;
        return min(get(2*v, lx, mx, l, r), get(2*v+1, mx+1, rx, l, r));
    }
public:
    SegTree(int n, string s): n(n), s(s), t(4*n), pref(n), pref2(n) {
        build_pref();
        build(1, 0, n - 1);
    }

    int get(int l, int r) {
        return get(1, 0, n - 1, l - 1, r - 1);
    }
};

void solve() {
    int n;
    cin >> n;
    int q;
    cin >> q;
    int g;
    cin >> g;
    if (g < 6) {
        string s;
        cin >> s;
        string prim(s);
        while(q--) {
            int l2, r2;
            cin >> l2 >> r2;
            vector<int> pref(2*n), suf(2*n);
            for (int i = 0; i < 2*n; i++) {
                if (i != 0) pref[i] = pref[i - 1];
                if (s[i] == '(')
                    pref[i]++;
                else
                    pref[i]--;
            }
            for (int i = 2 * n - 1; i >= 0; i--) {
                if (i != 2 * n - 1) suf[i] = suf[i + 1];
                if (s[i] == '(')
                    suf[i]++;
                else
                    suf[i]--;
            }
            int l = 0, r = 2 * n - 1;
            while(l < 2*n) {
                if (pref[l] < 0) {
                    break;
                }
                l++;
            }
            while(r >= 0) {
                if (suf[r] > 0) {
                    break;
                }
                r--;
            }
            if (l > r) {
                cout << 0 << '\n';
                break;
            }
            int pl = 0, pr = 0;
            while(r > l) {
                if (pref[l] + pl == -1 and suf[r] + pr == 1) {
                    swap(s[l], s[r]);
                    pl += 2;
                    pr -= 2;
                }
                while(l < r) {
                    if (pref[l] + pl < 0) {
                        break;
                    }
                    l++;
                }
                while(r > l) {
                    if (suf[r] + pr > 0) {
                        break;
                    }
                    r--;
                }
            }
            int diff = 0;
            for (int i = 0; i < 2 * n; i++) {
                if (prim[i] != s[i]) {
                    diff++;
                }
            }
            cout << diff / 2 << '\n';
            //cout << s << '\n';
        }
    } else {
        string s;
        cin >> s;
        SegTree st(2*n, s);
        while(q--) {
            int l, r;
            cin >> l >> r;
            int ans = st.get(l, r);
            if (ans == 0) {
                cout << 0 << '\n';
            } else {
                cout << abs(ans) << '\n';
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
