#include <bits/stdc++.h>
#define int long long
using namespace std;
const int NMAX = 1e5+2;
using edge = tuple<int, int, int>;
using pii = pair<int, int>;
int n,q,vf[NMAX],k,cntglobal;
vector<pii> v[NMAX];
vector<edge> edges;
map<int, int> sp;
map<int, vector<pii>> events;

int gauss(int n){
    return n * (n-1)/2;
}

struct DSU {
    int n;
    vector<int> t, sz;
    DSU(int _n){
        n = _n;
        t.resize(n+1);
        sz.resize(n+1);
        for(int i = 1; i <= n; i++){
            t[i] = i;
            sz[i] = 1;
        }
    }
    int getroot(int nod){
        if(t[nod] == nod){
            return nod;
        }
        return t[nod] = getroot(t[nod]);
    }
    bool areJoined(int x, int y){
        return (getroot(x) == getroot(y));
    }
    void join(int x, int y){
        if(areJoined(x, y)){
            return ;
        }
        int rootx = getroot(x), rooty = getroot(y);
        if(sz[rootx] < sz[rooty]){
            swap(rootx, rooty);
        }
        t[rooty] = rootx;
        cntglobal -= gauss(sz[rootx]);
        cntglobal -= gauss(sz[rooty]);
        sz[rootx] += sz[rooty];
        cntglobal += gauss(sz[rootx]);
    }
};

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> q;
    set<int> s;
    for(int i = 1; i < n; i++){
        int x, y, w;
        cin >> x >> y >> w;
        v[x].push_back({y, w});
        v[y].push_back({x, w});
        events[w].push_back({x, y});
    }
    int sum = 0, cntprev = 0, idx = 0;
    vector<pii> misto(events.size()+1);
    misto[idx++] = {0, 0};
    DSU ds(n);
    for(auto [cost, list]: events){
        for(auto [x, y]: list){
            ds.join(x, y);
        }
        int x = cntglobal - cntprev;
        sum += cost * x;
        misto[idx++] = {cost, sum};
        cntprev = cntglobal;
    }
    while(q--){
        int l, r;
        cin >> l >> r;
        auto getIdx = [&](int pos) -> int {
            int st = 0, dr = misto.size()-1;
            int ans = 0;
            while(st <= dr){
                int mid = (st+dr)/2;
                if(misto[mid].first <= pos){
                    ans = mid;
                    st = mid+1;
                }else{
                    dr = mid-1;
                }
            }
            return ans;
        };
        cout << misto[getIdx(r)].second - misto[getIdx(l-1)].second << "\n";
    }
    return 0;
}
