#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#warning That's not AS, that's my AS

typedef long long ll;

struct Edge {
  int u, v, w;
  bool operator < (const Edge &other) const {
    return w < other.w;
  };
};

struct Query {
  int l, r;
};

struct DSU {
  std::vector<int> p, sz;
  DSU() {}
  void init(int n) {
    p.resize(n + 1);
    for (int i = 1; i <= n; i++) {
      p[i] = i;
    }
    sz.resize(n + 1, 1);
  }
  int root(int u) {
    return p[u] == u? u : p[u] = root(p[u]);
  }
  void join(int u, int v) {
    u = root(u);
    v = root(v);
    if (u != v) {
      if (sz[u] > sz[v]) {
        std::swap(u, v);
      }
      p[u] = v;
      sz[v] += sz[u];
    }
  }
  int getSize(int u) {
    u = root(u);
    return sz[u];
  }
};

int main() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);
  std::cout.tie(0);

  int n, q;
  std::cin >> n >> q;
  std::vector<Edge> e(n - 1);
  std::vector<int> norm;
  for (auto &[u, v, w] : e) {
    std::cin >> u >> v >> w;
    norm.push_back(w);
  }
  std::vector<Query> Q(q);
  for (auto &[l, r] : Q) {
    std::cin >> l >> r;
    norm.push_back(l);
    norm.push_back(r);
  }

  std::sort(norm.begin(), norm.end());
  norm.erase(std::unique(norm.begin(), norm.end()), norm.end());

  std::vector<int> rev((int) norm.size() + 1, 0);

  for (auto &[u, v, w] : e) {
    int aux = w;
    w = std::lower_bound(norm.begin(), norm.end(), w) - norm.begin() + 1;
    rev[w] = aux;
  }
  for (auto &[l, r] : Q) {
    l = std::lower_bound(norm.begin(), norm.end(), l) - norm.begin() + 1;
    r = std::lower_bound(norm.begin(), norm.end(), r) - norm.begin() + 1;
  }
  std::sort(e.begin(), e.end());

  std::vector<ll> answer((int) norm.size() + 1, 0);

  DSU dsu;
  dsu.init(n);

  for (const auto &[u, v, w] : e) {
    answer[w] += (ll) dsu.getSize(u) * dsu.getSize(v);
    dsu.join(u, v);
  }

  for (int i = 1; i <= (int) norm.size(); i++) {
//    std::cout << answer[i] << ' ';
    answer[i] = (ll) answer[i] * rev[i];
  }

  for (int i = 1; i < (int) answer.size(); i++) {
    answer[i] += answer[i - 1];
  }

  for (const auto &[l, r] : Q) {
    std::cout << answer[r] - answer[l - 1] << '\n';
  }

  return 0;
}
