#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
using ll = long long;

struct SegmentTree {
  int n;
  vector<int> data;
  
  void build(int u, int st, int dr, vector<int>& a) {
    if (st == dr) data[u] = a[st];
    else {
      int mid = (st + dr) / 2;
      build(2 * u, st, mid, a);
      build(2 * u + 1, mid + 1, dr, a);
      data[u] = min(data[2 * u], data[2 * u + 1]);
    }
  }
  int query(int u, int st, int dr, int l, int r) {
    if (st >= l && dr <= r) return data[u];
    int mid = (st + dr) / 2, res = n + 1;
    if (l <= mid) res = min(res, query(2 * u, st, mid, l, r));
    if (mid < r) res = min(res, query(2 * u + 1, mid + 1, dr, l, r));
    return res;
  }
  int query(int l, int r) {
    return query(1, 1, n, l, r);
  }
  
  SegmentTree(int n, vector<int>& a) {
    this->n = n;
    data.assign(4 * (n + 1), n + 1);
    build(1, 1, n, a);
  };
};

int32_t main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  
  int n, q, G;
  string s;
  cin >> n >> q >> G >> s;
  s = '$' + s;
  n *= 2;
  
  vector<int> a(n + 1);
  for (int i = 1; i <= n; ++i) {
    a[i] = a[i - 1];
    if (s[i] == '(') ++a[i];
    else --a[i];
  }
  
  SegmentTree aint(n, a);
  
  cout << endl << endl;
  while (q--) {
    int l, r;
    cin >> l >> r;
    
    int minbal = n + 1;
    minbal = min(minbal, aint.query(l, r));
    //for (int i = l; i <= r; ++i) minbal = min(minbal, a[i]);
    
    minbal -= a[l - 1];
    int ans = (-minbal + 1) / 2;
    
    cout << ans << endl;
  }
}
/*
5 1 1
()))(()(()
7 10
*/