#include <bits/stdc++.h>
using namespace std;

using ll = long long;

struct DSU {
  int n;
  vector<int> dsu, sz;
  
  int find(int a) {
    if (dsu[dsu[a]] != dsu[a]) dsu[a] = find(dsu[a]);
    return dsu[a];
  }
  void unite(int a, int b) {
    a = find(a); b = find(b);
    if (a == b) return;
    if (sz[a] < sz[b]) swap(a, b);

    dsu[b] = a;
    sz[a] += sz[b];
  }
  
  DSU(int n) {
    this->n = n;
    dsu.assign(n + 1, 0);
    sz.assign(n + 1, 1);
    for (int i = 1; i <= n; ++i) dsu[i] = i;
  }
};

struct Edge {
  int u, v, w;
  bool operator<(Edge b) const {
    return w < b.w;
  }
};

int main() {
  int n, q;
  cin >> n >> q;
  
  vector<Edge> edges(n - 1);
  for (int i = 0; i < n - 1; ++i) cin >> edges[i].u >> edges[i].v >> edges[i].w;
  sort(edges.begin(), edges.end());
  
  DSU d(n);
  vector<ll> pref(n);
  for (int i = 0; i < n - 1; ++i) {
    Edge e = edges[i];

    int a = d.find(e.u), b = d.find(e.v);
    assert(a != b);
    pref[i] = (ll)d.sz[a] * d.sz[b] * e.w;
    d.unite(a, b);
    
    if (i > 0) pref[i] += pref[i - 1];
  }
  
  while (q--) {
    int l, r;
    cin >> l >> r;
    
    int st = 0, dr = n - 2, L = n - 1, R = -1;
    while (st <= dr) {
      int mid = (st + dr) / 2;
      if (edges[mid].w >= l) {
        L = mid;
        dr = mid - 1;
      } else st = mid + 1;
    }
    st = 0, dr = n - 2;
    while (st <= dr) {
      int mid = (st + dr) / 2;
      if (edges[mid].w <= r) {
        R = mid;
        st = mid + 1;
      } else dr = mid - 1;
    }
    
    if (R < L) cout << "0\n";
    else {
      ll ans = pref[R];
      if (L > 0) ans -= pref[L - 1];
      cout << ans << endl;
    }
  }
}
