#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
using ll = long long;
#define int ll

int mod(int a, int b) {
  return (a % b + b) % b;
}
int get_ans(int x, int y) {
  int ans = 0;
  int use_y = x / __gcd(x, y), use_x = y / __gcd(x, y);
  
  if (x < y) {
    ans = y + mod(use_y - 1, x);
  } else {
    ans = x + mod(use_x - 1, y);
  }
  
  return ans;
}

const int N = 2e5 + 5, INF = 1e9 + 1;

bool vis[N];
vector<int> adj[N];

vector<int> order;
void topdfs(int u) {
  vis[u] = true;
  for (int v : adj[u]) {
    if (!vis[v]) topdfs(v);
  }
  order.push_back(u);
}

bool check(int x, int y, int len) {
  vector<vector<int>> aj(len + 1);
  for (int i = 0; i <= len; ++i) {
    if (i + x <= len) aj[i].push_back(i + x);
    if (i - y >= 0) aj[i].push_back(i - y);
  }
  
  vector<int> color(len + 1);
  bool cycle = false;
  auto dfs = [&](int u, auto&& self) -> void {
    color[u] = 1;
    for (int v : aj[u]) {
      if (color[v] == 1) cycle = true;
      else if (color[v] == 0) self(v, self);
    }
    color[u] = 2;
  };
  
  for (int i = 0; i <= len; ++i) {
    if (color[i] == 0) dfs(i, dfs);
  }
  return cycle;
}

const int bulan = 500;

int32_t main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  
  int t, x1 = 0, y1 = 0, ans1 = 0;
  cin >> t;
  
  for (int test = 0; test < t; ++test) {
    int x, y;
    cin >> x >> y;
    if (test == 0) {
      x1 = x; y1 = y;
    }
    
    int xx = get_ans(x, y) - 1;
    int st = max({x - 1, y - 1, xx - bulan}), dr = xx + bulan, ans = st;
    while (st <= dr) {
      int mid = (st + dr) / 2;
      if (!check(x, y, mid)) {
        ans = mid;
        st = mid + 1;
      } else dr = mid - 1;
    }
    int len = ans;
    if (test == 0) ans1 = len;
    /*
    int len = get_ans(x, y) - 1;
    while (len > 0 && check(x, y, len)) --len;
    while (!check(x, y, len + 1)) ++len;*/
    
    cout << len << " ";
  }
  cout << endl;
  
  int x = x1, y = y1;
  int len = ans1;
  
  for (int i = 0; i <= len; ++i) {
    if (i + x <= len) adj[i].push_back(i + x);
    if (i - y >= 0) adj[i].push_back(i - y);
  }

  for (int i = 0; i <= len; ++i) {
    if (!vis[i]) topdfs(i);
  }
  reverse(order.begin(), order.end());
  
  vector<int> val(len + 1);
  for (int u : order) {
    for (int v : adj[u]) {
      val[v] = max(val[v], val[u] + 1);
    }
  }
  
  for (int i = len; i >= 0; --i) val[i] -= val[0];
  assert(val[0] == 0);
  for (int i = len; i >= 1; --i) val[i] -= val[i - 1];
  for (int i = 1; i <= len; ++i) cout << val[i] << " ";
}
