#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const int MAXN = 400228;
int pref[MAXN];
int n, q, g;
string s;

struct Node {
    int sum = 0;
    int prefmin;
};
Node tree[4 * MAXN];

Node join(Node a, Node b) {
    Node c;
    c.sum = a.sum + b.sum;
    c.prefmin = min(a.prefmin, a.sum + b.prefmin);
    return c;
}

void build(int v, int tl, int tr) {
    if (tl == tr) {
        if (s[tl] == '(') {
            tree[v].sum = 1;
        } else {
            tree[v].sum = -1;
        }
        tree[v].prefmin = min(0, tree[v].sum);
    } else {
        int tm = (tl + tr) / 2;
        build(2 * v, tl, tm);
        build(2 * v + 1, tm + 1, tr);
        tree[v] = join(tree[2 * v], tree[2 * v + 1]);
    }
}

Node query(int v, int tl, int tr, int l, int r) {
    if (l <= tl && tr <= r) {
        return tree[v];
    }
    int tm = (tl + tr) / 2;
    if (l <= tm && r <= tm) {
        return query(2 * v, tl, tm, l, r);
    } else if (tm + 1 <= l && tm + 1 <= r) {
        return query(2 * v + 1, tm + 1, tr, l, r);
    } else {
        return join(query(2 * v, tl, tm, l, tm), query(2 * v + 1, tm + 1, tr, tm + 1, r));
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> q >> g >> s;
    s = "#" + s;
    if (g <= 5) {
        int f = 0, res = 0;
        for (int i = 1; i <= 2 * n; i++) {
            if (s[i] == '(') {
                f++;
            } else {
                if (f == 0) {
                    res++;
                    f++;
                } else {
                    f--;
                }
            }
        }
        res += f / 2;
        cout << res / 2 << '\n';
        return 0;
    }
    for (int i = 1; i <= 2 * n; i++) {
        pref[i] = pref[i - 1] + (s[i] == '(' ? +1 : -1);
    }
    build(1, 1, 2 * n);
    while (q--) {
        int l, r;
        cin >> l >> r;
        if (pref[r] - pref[l - 1] == 0 && query(1, 1, 2 * n, l, r).prefmin >= 0) {
            cout << 0 << '\n';
        } else {
            cout << 69 << '\n';
        }
    }
    return 0;
}
