#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define int ll
const int MAXN = 100228;
int n, q;
int t[MAXN], sz[MAXN];
bool seen[MAXN];
vector<pair<int, int>> v;
ll pref[MAXN];


struct Edge {
    int cost;
    int x;
    int y;
};
vector<Edge> edges;
map<int, ll> f;

int root(int x) {
    if (x == t[x]) {
        return x;
    }
    return t[x] = root(t[x]);
}

ll get(int x, int y) {
    return sz[root(x)] * sz[root(y)];
}

void join(int x, int y) {
    x = root(x);
    y = root(y);
    if (x == y) {
        return;
    }
    if (sz[x] < sz[y]) {
        swap(x, y);
    }
    t[y] = x;
    sz[x] += sz[y];
}

int get(int x) {
    int l = 1, r = v.size(), sol = 0;
    while (l <= r) {
        int m = (l + r) / 2;
        if (v[m - 1].first <= x) {
            l = m + 1;
            sol = m;
        } else {
            r = m - 1;
        }
    }
    return sol;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> q;
    for (int i = 1; i < n; i++) {
        int x, y, cost;
        cin >> x >> y >> cost;
        edges.push_back({cost, x, y});
    }
    sort(edges.begin(), edges.end(), [&](Edge a, Edge b) {
        return a.cost < b.cost;
    });
    for (int i = 1; i <= n; i++) {
        t[i] = i;
        sz[i] = 1;
    }
    int i = 0;
    while (i < edges.size()) {
        int j = i;
        ll res = 0;
        while (j < edges.size() && edges[j].cost == edges[i].cost) {
            res += get(edges[j].x, edges[j].y);
            join(edges[j].x, edges[j].y);
            j++;
        }
        f[edges[i].cost] = edges[i].cost * res;
        // j = i;
        // while (j < edges.size() && edges[j].cost == edges[i].cost) {
        // join(edges[j].x, edges[j].y);
        //  j++;
        // }
        i = j;
    }

    for (auto i: f) {
        v.push_back(make_pair(i.first, i.second));
    }
    for (int i = 1; i <= v.size(); i++) {
        //cout << v[i - 1].first << ' ' << v[i - 1].second << '\n';
        pref[i] = pref[i - 1] + v[i - 1].second;
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        cout << pref[get(r)] - pref[get(l - 1)] << '\n';
    }
    return 0;
}
