#include <iostream>
#include <queue>
#include <vector>
#include <climits>

using namespace std;

const long long nmax = 100005;
const long long inf = INT_MAX;

struct vect{
long long vecin, c;
};

long long n, q, fr[nmax], cost[nmax], maxi;
vector<vect> a[nmax];
priority_queue< pair<long long, long long> > Q;

long long find_min()
{
    while(!Q.empty() && fr[Q.top().second])
        Q.pop();

    if(Q.empty())
        return -1;

    long long nod = Q.top().second;
    Q.pop();
    return nod;
}

void Dija(long long nod)
{
    for(long long i = 1; i <= n; i ++)
        cost[i] = inf, fr[i] = 0;
    cost[nod] = 0;

    Q.push({0, nod});
    for(long long i = 1; i <= n; i ++)
    {
        nod = find_min();
        if(nod == -1)
            return ;

        fr[nod] = 1;
        for(auto x : a[nod])
            if(cost[x.vecin] > max(cost[nod], x.c))
            {
                cost[x.vecin] = max(cost[nod], x.c);
                Q.push({x.c, x.vecin});
            }
    }
}

int main()
{
    cin >> n >> q;
    for(long long i = 1; i < n; i ++)
    {
        long long x, y, c;
        cin >> x >> y >> c;
        a[x].push_back({y, c});
        a[y].push_back({x, c});
    }

    for(long long i = 1; i <= q; i ++)
    {
        long long x, y;
        long long sumi = 0;
        cin >> x >> y;
        for(long long i = 1; i <= n; i ++)
        {
            Dija(i);
            for(long long j = i + 1; j <= n; j ++)
                if(x <= cost[j]  && cost[j] <= y)
                    sumi += cost[j];
        }

        cout << sumi << '\n';
    }
    return 0;
}
